#!/usr/bin/perl -w

# Copyright 2008, 2009, 2010 Kevin Ryde.

# This file is part of miscbits-el.
#
# miscbits-el is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3, or (at your option) any later
# version.
#
# miscbits-el is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with miscbits-el; see the file COPYING.  Failing that, go to
# <http://www.gnu.org/licenses/>.

use strict;
use warnings;
my $time = time;

my $pat = qr/^[[:alpha:]_][[:alnum:]_]*$/;

foreach my $dir (@INC) {
  opendir my $h, $dir or next;
  my @classes = grep {$_ ne 'auto'} grep {/$pat/} readdir $h;

  while (@classes) {
    my $class = pop @classes;
    my $classdir = "$dir/$class";

    # print $classdir;

    #               (let ((pm-filename (concat classdir "/" basename ".pm")))
    #                 (when (file-exists-p pm-filename)
    #                   (if found-pm-class
    #                       (unless (equal class found-pm-class)
    #                         (throw 'stop nil)) ;; exists but not unique
    #                     (setq found-pm-class class)
    #                     (setq found-pm-filename pm-filename))))
    #
    #               (let ((pod-filename (concat classdir "/" basename ".pod")))
    #                 (when (file-exists-p pod-filename)
    #                   (if found-pod-class
    #                       (setq found-pod-filename nil) ;; not unique
    #                     (setq found-pod-class class)
    #                     (setq found-pod-filename pod-filename))))

    if (opendir $h, $classdir) {
      push @classes, grep {/$pat/} readdir $h;
    }
  }
}

print time() - $time,"\n";
