;; Copyright 2009, 2013 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(progn
  (add-hook 'image-mode-hook 'imagetext-show)

  (defconst my-image
    "/* XPM */
static char *x[] = {
/* columns rows colors chars-per-pixel */
\"32 32 2 1 \",
\"  c black\",
\". c white\",
\"                                \",
\"   ........          ......     \",
\"   ........          .......    \",
\"   ........          ........   \",
\"   ........          .........  \",
\"                                \",
\"                                \",
\"                                \",
\"            ......              \",
\"          ..........            \",
\"        ..............          \",
\"     ......       ......        \",
\"   ......           ......      \",
\"   ......           ......      \",
\"    .....            .....      \",
\"     .....           .....      \",
\"     .....             .....    \",
\"     .....             .....    \",
\"      .....           .....     \",
\"      .....       ......        \",
\"        ..............          \",
\"          ..........            \",
\"            ......              \",
\"                                \",
\"                                \",
\"                                \",
\"                                \",
\"   ........         .......     \",
\"   ........        ........     \",
\"    .......       .........     \",
\"     ......       .........     \",
\"                                \",
};
")

  (let ((frame (make-frame '((width  . 60)
                             (height . 15)
                             ;; (font . "5x8")
                             (font . "6x10")
                             ))))
    (select-frame-set-input-focus frame)
    (ignore-errors (delete-file "/tmp/d-imagetext--sample.xpm"))
    (with-temp-buffer
      (insert my-image)
      (write-file "/tmp/d-imagetext--sample.xpm"))

    (shell-command "
convert -strip /tmp/d-imagetext--sample.xpm \
               /tmp/d-imagetext--sample.png;
pngtextadd --keyword=Author --text='Kevin Ryde' \
    /tmp/d-imagetext--sample.png;
pngtextadd --keyword=Description --text='An image, blah blah blah.' \
    /tmp/d-imagetext--sample.png;
")

    (let ((buffer (find-buffer-visiting "/tmp/d-imagetext--sample.png")))
      (if buffer (kill-buffer buffer)))
    (find-file "/tmp/d-imagetext--sample.png")

    (sit-for 1)
    (sit-for 1)
    (sit-for 1)
    (sit-for 1)

    (shell-command (format "xwd -id %s >/tmp/d-imagetext--screenshot.xwd"
                           (frame-parameter nil 'outer-window-id)))
    (delete-frame frame)

    (shell-command "
convert -strip /tmp/d-imagetext--screenshot.xwd \
               /tmp/d-imagetext--screenshot.png;
pngtextadd --keyword=Title --text='imagetext.el screenshot' \
    /tmp/d-imagetext--screenshot.png;
pngtextadd --keyword=Author --text='Kevin Ryde' \
    /tmp/d-imagetext--screenshot.png;
pngtextadd --keyword=Copyright --text='Copyright 2009, 2013 Kevin Ryde'
    /tmp/d-imagetext--screenshot.png;
pngtextadd --keyword=Homepage --text='http://user42.tuxfamily.org/imagetext/index.html' \
    /tmp/d-imagetext--screenshot.png;
pngtextadd --keyword=Software --text='Generated by d-imagetext--screenshot.el, imagemagic and pngtextadd.' \
    /tmp/d-imagetext--screenshot.png;
pngtextadd --keyword=Description --text='A sample screenshot of imagetext.el.' \
    /tmp/d-imagetext--screenshot.png;
")
    (shell-command
     (format "pngtextadd --keyword='Creation Time' --text='%s' \
                  /tmp/d-imagetext--screenshot.png"
             (format-time-string "%a, %d %b %Y %H:%M:%S %z")))

    (require 'imagetext)
    (add-hook 'image-mode-hook 'imagetext-show)

    (find-file "/tmp/d-imagetext--screenshot.png")))


(setq foo (frame-parameters nil))
