;; Copyright 2011 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.



;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))


;;-----------------------------------------------------------------------------
;; cf .7z

;; unless perhaps incorporated into emacs in the future
(unless (member t (mapcar (lambda (vec)
                            (let ((regexp (elt vec 0)))
                              (numberp (string-match regexp "foo.7z"))))
                          jka-compr-compression-info-list))

  (add-to-list 'jka-compr-compression-info-list
               ["\\.7z\\'"
                "compressing"    "lzma"  ("-c" "-q")
                "uncompressing"  "lzma"  ("-c" "-q" "-d")
                nil t "7z\274\257\047\034"])

  ;; if already enabled then toggle to get our addition recognised
  ;; (note no `auto-compression-mode' variable in xemacs21)
  (when jka-compr-added-to-file-coding-system-alist
    (auto-compression-mode 0)
    (auto-compression-mode 1)))

;; .gz.bin too
(eval-after-load "jka-compr"
  '(progn
     (add-to-list 'jka-compr-compression-info-list
                  ;; this element copied from emacs 22
                  ["\\.gz.bin\\'"
                   nil nil nil
                   "uncompressing" "gzip" ("-c" "-q" "-d")
                   nil t "\037\213"])

     ;; if already enabled then toggle to get addition recognised
     ;; (note no `auto-compression-mode' variable in xemacs 21)
     (when jka-compr-added-to-file-coding-system-alist
       (auto-compression-mode 0)
       (auto-compression-mode 1))))

;; .bz2.bin too
(eval-after-load "jka-compr"
  '(progn
     (add-to-list 'jka-compr-compression-info-list
                  ;; this element copied from emacs 23
                  ["\\.bz2\\.bin\\'"
                   "bzip2ing"        "bzip2"         nil
                   "bunzip2ing"      "bzip2"         ("-d")
                   nil t "BZh"])

     ;; if already enabled then toggle to get addition recognised
     ;; (note no `auto-compression-mode' variable in xemacs 21)
     (when jka-compr-added-to-file-coding-system-alist
       (auto-compression-mode 0)
       (auto-compression-mode 1))))

