;; Copyright 2009 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(progn
  (add-to-list 'load-path (expand-file-name ".."))

  (let* ((mine-field-wsize 30)
         (mine-field-hsize 15)
         (mine-amount      45)
         (frame            (make-frame `((width  . ,mine-field-wsize)
                                         (height . ,mine-field-hsize)
                                         (font . "6x10")
                                         ))))
    (select-frame-set-input-focus frame)
    (switch-to-buffer (get-buffer-create "Mine"))
    (mine-sweeper)

    (mine-move-down)
    (mine-move-down)
    (mine-move-right)
    (mine-move-right)
    (mine-move-right)
    (mine-move-right)
    (mine-open)
    (sit-for 1)

    (or (get-buffer "Mine")
        (error "Game over"))
    (shell-command (format "xwd -id %s >/tmp/d-mine-sweeper-auto--screenshot.xwd"
                           (frame-parameter nil 'outer-window-id)))
    (mine-clean-and-quit)
    (delete-frame frame)

    (shell-command "
convert -strip /tmp/d-mine-sweeper-auto--screenshot.xwd \
               /tmp/d-mine-sweeper-auto--screenshot.png;
pngtextadd --keyword=Title --text='mine-sweeper-auto.el screenshot' \
    /tmp/d-mine-sweeper-auto--screenshot.png;
pngtextadd --keyword=Author --text='Kevin Ryde' \
    /tmp/d-mine-sweeper-auto--screenshot.png;
pngtextadd --keyword=Copyright --text='Copyright 2009 Kevin Ryde'
    /tmp/d-mine-sweeper-auto--screenshot.png;
pngtextadd --keyword=Homepage --text='http://user42.tuxfamily.org/mine-sweeper-auto/index.html' \
    /tmp/d-mine-sweeper-auto--screenshot.png;
pngtextadd --keyword=Software --text='Generated by d-mine-sweeper-auto--screenshot.el, imagemagic and pngtextadd.' \
    /tmp/d-mine-sweeper-auto--screenshot.png;
pngtextadd --keyword=Description --text='A sample screenshot of mine-sweeper-auto.el running the mine-sweeper-auto program in an Emacs buffer.' \
    /tmp/d-mine-sweeper-auto--screenshot.png;
")
    (shell-command
     (format "pngtextadd --keyword='Creation Time' --text='%s' \
                  /tmp/d-mine-sweeper-auto--screenshot.png"
             (format-time-string "%a, %d %b %Y %H:%M:%S %z")))

    (require 'imagetext)
    (add-hook 'image-mode-hook 'imagetext-show)

    (find-file "/tmp/d-mine-sweeper-auto--screenshot.png")))


(setq foo (frame-parameters nil))
