;; Copyright 2009, 2010 Kevin Ryde

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(add-to-list 'load-path (expand-file-name ".."))

(defun my-in-first-line-p ()
  "Return non-nil if point is the first line of the buffer."
  (save-excursion
    (not (search-backward "\n" nil t))))

(defun my-run-test ()
  (let ((count 0))

    ;;-------------------------------------------------------------------------
    ;; load

    (require 'startup-file-name-history)

    (if (not (boundp 'command-line-functions))
        (message "skip, no command-line-functions")

      (unless (memq 'startup-file-name-history-add
                    command-line-functions)
        (error "startup-file-name-history-add not added to command-line-functions"))
      (setq count (1+ count)))


    ;;-------------------------------------------------------------------------
    ;; unload-feature
    ;;
    ;; For emacs22 up nothing special needed for `unload-feature'.
    ;; `unload-feature-special-hooks' includes
    ;; `compilation-finish-functions' so if
    ;; `compilation-recenter-end-at-finish' is in there it's removed
    ;; automatically.

    (if (not (boundp 'command-line-functions))
        (message "skip, no command-line-functions")

      (unload-feature 'startup-file-name-history)

      (if (not (boundp 'unload-feature-special-hooks))
          (message "skip, no unload-feature-special-hooks")

        (when (memq 'startup-file-name-history-add
                    command-line-functions)
          (error "startup-file-name-history-add not removed from command-line-functions"))
        (setq count (1+ count))))


    ;;-------------------------------------------------------------------------
    (message "  %d tests" count)
    count))
